<template>
  <div v-loading="loading">
    <CDataTable
      hover
      :items="data"
      :fields="FIELDS"
      class="user-table"
    >
      <template #image="{item}">
        <td>
          <div class="c-avatar">
            <img :src="item.image" class="c-avatar-img" alt="avatar">
          </div>
        </td>
      </template>

      <template #status="{item}">
        <td>
          <span :class="`badge badge-${item.status === 1 ? 'primary' : 'secondary'}`">
            {{ item.status === 1 ? 'Active' : 'Inactive' }}
          </span>
        </td>
      </template>

      <template #action="{ item }">
        <td class="white-space-nowrap">
          <CButton size="sm" color="primary" @click="onShowDetail(item.id)">
            <font-awesome-icon :icon="['fas', 'pencil-alt']" />
          </CButton>
          &nbsp;
          <CButton size="sm" color="danger" @click="onDelete(item.id)">
            <font-awesome-icon :icon="['fas', 'trash-alt']" />
          </CButton>
        </td>
      </template>
    </CDataTable>
  </div>
</template>

<style lang="scss" scoped>
  .user-table {
    /deep/ {
      table {
        border-bottom: 1px solid #d8dbe0;
        margin-bottom: 0;
        thead {
          tr {
            th {
              &.id {
                width: 60px;
              }
              &.image {
                width: 80px;
              }
              &.email {
                width: 250px;
              }
              &.phone {
                width: 150px;
              }
              &.status {
                width: 100px;
              }
              &.action {
                width: 93px;
              }
            }
          }
        }
      }
    }
  }
</style>

<script>
const EVENT_DELETE = 'delete'
const EVENT_SHOW_DETAIL = 'show-detail'

const FIELDS = [
  { key: 'id', label: 'ID', _classes: 'id' },
  { key: 'image', label: 'Image', _classes: 'image' },
  { key: 'name', label: 'User name', _classes: 'name' },
  { key: 'email', label: 'Email', _classes: 'email' },
  { key: 'phone', label: 'Phone', _classes: 'phone' },
  { key: 'status', label: 'Status', _classes: 'status' },
  { key: 'action', label: 'Action', _classes: 'action' }
]

export default {
  props: {
    /**
     * User list
     */
    data: {
      type: Array,
      default: () => []
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    /**
     * Get FIELDS of header table
     *
     * @return {array} FIELDS of header table
     */
    FIELDS () {
      return FIELDS
    }
  },

  methods: {
    /**
     * Event show user detail modal
     *
     * @param {string} user - User
     */
    onShowDetail (id) {
      this.$emit(EVENT_SHOW_DETAIL, id)
    },

    /**
     * Delete user
     *
     * @param {string} id - User id
     */
    onDelete (id) {
      this.$emit(EVENT_DELETE, id)
    }
  }
}
</script>
